      *******************************************************************
      *-----------------------------------------------------------------*
      *                                                                 *
      *        Copyright(c) by Bernd Riemke                             *
      *                        Riemke-IT Solutions                      *
      *                        An den Ruschen 27a                       *
      *                        D-28816 Stuhr                            *
      *                                                                 *
      *-----------------------------------------------------------------*
      $SET ANS85 CASE
      *
      *
      *        TEST-PRG.CBL      Aufrufe der Unterprogramme
      *        ------------      --------------------------
      *
      *        LETZTE NDERUNG:
      *        ================
      *
      *        01.01.2017  Bernd Riemke
      *                    - Angelegt
      *
      *
      *=================================================================
       IDENTIFICATION DIVISION.
       PROGRAM-ID.             TEST-PRG.
       AUTHOR.                 BERND RIEMKE.
       INSTALLATION.           BERND RIEMKE.
       DATE-WRITTEN.           01-Januar-2017.
       DATE-COMPILED.
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SOURCE-COMPUTER.        IBM-PC-COMP.
       OBJECT-COMPUTER.        IBM-PC-COMP.
       SPECIAL-NAMES.          CALL-CONVENTION 66 IS WINAPI
                               DECIMAL-POINT      IS COMMA.
      *
       INPUT-OUTPUT SECTION.
      *---------------------
      *
       FILE-CONTROL.
      *-------------
      *
       DATA DIVISION.
      *==============
      *
       FILE SECTION.
      *-------------
      *
       WORKING-STORAGE SECTION.
      *------------------------
      *
       01 TOOL-POINTER         USAGE PROCEDURE-POINTER.
       01 DUMMY-POINTER        USAGE PROCEDURE-POINTER.
       01 FEHLER-KZ            PIC 9 VALUE ZEROES.

       COPY "API-MSGBOX.CPY".
      *
      *
      *******************************************************************
       PROCEDURE DIVISION.
      *-------------------
      *
       HAUPTPROGRAMM SECTION.
      *

          PERFORM VORLAUF.
          PERFORM HAUPTLAUF.
          PERFORM NACHLAUF.

      *
       HAUPTPROGRAMM-E.
      *
          EXIT PROGRAM.
          STOP RUN.
      *
      *******************************************************************
       VORLAUF SECTION.
      *----------------

          SET DUMMY-POINTER        TO ENTRY  "DUMMY.DLL".
          SET TOOL-POINTER         TO ENTRY  "API-MSGBOXEN.DLL".

          IF  DUMMY-POINTER NOT EQUAL TO TOOL-POINTER
              CONTINUE
          ELSE
              DISPLAY "API-MSGBOXEN.DLL konnte nicht geladen werden !"
              AT 0101
              MOVE           1 TO FEHLER-KZ
              ACCEPT FEHLER-KZ AT 0202
          END-IF.

       VORLAUF-EE.
          EXIT.

      *******************************************************************
       HAUPTLAUF SECTION.
      *------------------

          IF  FEHLER-KZ = 1
              EXIT SECTION
          END-IF.

          INITIALIZE           LINK-API-MSGBOX

          MOVE "Windows API-MessageBox !"  TO LINK-API-MSGBOX-KOPF
          MOVE 'Diese MessageBox wurde ber'
                                           TO LINK-API-MSGBOX-Text1
          MOVE "Windows API Funktionen"
                                           TO LINK-API-MSGBOX-Text2
          MOVE "Erzeugt!"
                                           TO LINK-API-MSGBOX-Text3

          MOVE "OK"                        TO LINK-API-MSGBOX-BUTTON
            *> "OK"
            *> "OKCANCEL"
            *> "ABORTRETRYIGNORE"
            *> "YESNOCANCEL"
            *> "YESNO"
            *> "RETRYCANCEL"

          MOVE "INFORMATION"               TO LINK-API-MSGBOX-TYPE
            *> "FEHLER"
            *> "FRAGE"
            *> "INFORMATION"
            *> "HINWEIS"

          PERFORM CALL-API-MSGBOX.

      * Button Auswertung (Welcher wurde gedrckt !?)
      *
      *   EVALUATE LINK-API-MSGBOX-RETURN
      *
      *       WHEN 0
      *            PERFORM FEHLER
      *       WHEN 1
      *            PERFORM OK-GEDRUECKT
      *       WHEN 2
      *            PERFORM CANCEL-GEDRUECKT
      *       WHEN 3
      *            PERFORM WIEDERHOLEN-GEDRUECK
      *       WHEN 4
      *            PERFORM ABBRECHEN-GEDRUECK
      *       WHEN 5
      *            PERFORM IGNORIEREN-GEDRUECK
      *       WHEN 6
      *            PERFORM JA-GEDRUECK
      *       WHEN 7
      *            PERFORM NEIN-GEDRUECK
      *
      *   END-EVALUATE.
      *

       HAUPTLAUF-EE.
          EXIT.

      *******************************************************************
       NACHLAUF SECTION.
      *-----------------




       NACHLAUF-EE.
          EXIT.

      ******************************************************************
       CALL-API-MSGBOX SECTION.
      *------------------------

          CALL "API-MESSAGEBOXEN" USING LINK-API-MSGBOX
          END-CALL.

       CALL-API-MSGBOX-EE.
          EXIT.

      ******************************************************************
      ******************************************************************
      ******************************************************************
      ******************************************************************
      ******************************************************************
